<template>
    <div class="config">
        <div class="inputList">
            <div class="inpt">
                <label for="" class="label-text">
                    Title
                    <input v-model="currentItem.title" type="text" required />
                </label>
            </div>
            <div class="inpt">
                <label for="" class="label-text">
                    Description
                    <input v-model="currentItem.description" type="text" required />
                </label>
            </div>
            <div class="inpt">
                <label for="" class="label-text">
                    Image (link)
                    <input v-model="currentItem.img" type="text" required />
                </label>
            </div>
            <div class="inpt">
                <label class="label-text">
                    Keywords (one by one)
                    <input v-model="keywordsInput" type="text" required />
                </label>
                <button class="button-spec" @click="addKeyword">Add Keyword</button>
                <div v-for="(keyword, index) in currentItem.keywords" :key="index">
                    {{ keyword }}
                    <button class="button-spec keyword-btn" @click="removeKeyword(index)">
                        Remove
                    </button>
                </div>
            </div>
        </div>
        <div class="btns">
            <button class="button save" @click="onAction">{{ actionBtnText }}</button>
            <button v-if="itemId" class="button delete" @click="onDelete(currentItem.id)">
                Delete
            </button>
            <button class="button cancel" @click="back()">Cancel</button>
        </div>
    </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';

export default {
    name: 'ConfigRecipe',
    data() {
        return {
            currentItem: {
                title: '',
                description: '',
                keywords: [],
                img: '',
            },
            keywordsInput: '',
        };
    },
    computed: {
        ...mapGetters('recipes', ['getItemById']),
        // ...mapGetters('users', ['userPermissions']),
        itemId() {
            return this.$route.params.itemId;
        },
        actionBtnText() {
            return this.itemId ? 'Save Changes' : 'Create Item';
        },
    },
    watch: {
        '$route.params.itemId': {
            handler(newItemId) {
                if (!newItemId) {
                    this.currentItem = {
                        title: '',
                        description: '',
                        keywords: [],
                        img: 'https://img.icons8.com/ios/50/image--v1.png',
                    };
                } else {
                    this.currentItem = { ...this.getItemById(newItemId) };
                }
            },
            immediate: true,
        },
    },
    methods: {
        ...mapActions('recipes', ['addItem', 'updateItem', 'deleteItem']),
        onAction() {
            if (!this.itemId) {
                this.addItem(this.currentItem)
                    .then(() => {
                        this.$router.push({ name: 'recipes' });
                    })
                    .catch((error) => {
                        console.error(error);
                    });
            } else {
                this.updateItem({ itemId: this.itemId, data: this.currentItem })
                    .then(() => {
                        this.$router.push({ name: 'recipes' });
                    })
                    .catch((error) => {
                        console.error(error);
                    });
            }
        },
        // onAction() {
        //     if (this.userPermissions && this.userPermissions.update) {
        //         const actionPromise = !this.itemId
        //             ? this.addItem(this.currentItem)
        //             : this.updateItem({ itemId: this.itemId, data: this.currentItem });

        //         actionPromise
        //             .then(() => {
        //                 this.$router.push({ name: 'recipes' });
        //             })
        //             .catch((error) => {
        //                 console.error(error);
        //             });
        //     } else {
        //         console.error('Insufficient permissions to update.');
        //         // You might want to display a message or handle this situation in your UI
        //     }
        // },

        addKeyword() {
            if (this.keywordsInput.trim() !== '') {
                this.currentItem.keywords.push(this.keywordsInput.trim());
                this.keywordsInput = '';
            }
        },
        removeKeyword(index) {
            this.currentItem.keywords.splice(index, 1);
        },
        // onDelete(deleteRecipeId) {
        //     if (this.userPermissions.delete) {
        //         this.deleteItem(deleteRecipeId)
        //             .then(() => {
        //                 this.$router.push({ name: 'recipes' });
        //             })
        //             .catch((error) => {
        //                 console.error(error);
        //             });
        //     } else {
        //         console.error('Insufficient permissions to delete.');
        //     }
        // },
        onDelete(deleteRecipeId) {
            this.deleteItem(deleteRecipeId);
            this.$router.push({ name: 'recipes' });
        },
        back() {
            this.$router.push({ name: 'recipes' });
        },
        encodeImageFileAsURL() {

            var filesSelected = document.getElementById("inputFileToLoad").files;
            if (filesSelected.length > 0) {
                var fileToLoad = filesSelected[0];

                var fileReader = new FileReader();

                fileReader.onload = function (fileLoadedEvent) {
                    var srcData = fileLoadedEvent.target.result; // <--- data: base64

                    var newImage = document.createElement('img');
                    newImage.src = srcData;

                    document.getElementById("imgTest").innerHTML = newImage.outerHTML;
                    alert("Converted Base64 version is " + document.getElementById("imgTest").innerHTML);
                    console.log("Converted Base64 version is " + document.getElementById("imgTest").innerHTML);
                }
                fileReader.readAsDataURL(fileToLoad);
            }
        }

    },
};
</script>

<style lang="scss" scoped>
.config {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    text-align: center;
    padding: 5vh 1vw;
    margin: 5vh 30vw;
    background-color: #fff;
    border-radius: 10px;
    box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
    color: black;
    font-size: 100%;
}

.label-text {
    display: flex;
    flex-direction: column;
    margin-bottom: 3vh;

    input {
        padding: 12px;
        border-radius: 5px;
        border: 1px solid #ccc;
        background-color: #f8f8f8;
        color: #333;
        outline: none;
    }
}

.button-spec {
    background-color: #5cb85c;
    border: 2px solid #4cae4c;
    cursor: pointer;
    overflow: hidden;
    border-radius: 30px;
    color: #fff;
    width: fit-content;
    appearance: none;
    outline: none;

    &.keyword-btn {
        background-color: #d9534f;
        border: 2px solid #c9302c;
        margin: 0.2rem;
    }
}

.btns {
    display: flex;
    gap: 20px;
    margin-top: 3vh;

    .button {
        padding: 15px 20px;
        cursor: pointer;
        overflow: hidden;
        border-radius: 30px;
        font-size: 18px;
        transition: background-color 0.3s, color 0.3s, border-color 0.3s;
        appearance: none;
        outline: none;
    }

    .save {
        background-color: #5cb85c;
        color: #fff;
        border: 2px solid #4cae4c;
    }

    .delete {
        background-color: #d9534f;
        color: #fff;
        border: 2px solid #c9302c;
    }

    .cancel {
        background-color: #777;
        color: #fff;
        border: 2px solid #555;
    }
}
</style>
